QGIS Application - Bug report #7679
DBManager does not release PostGIS connections
2013-04-22 07:47 PM - Nyall Dawson

Status: Closed

Priority: Normal

Assignee:

Category: DB Manager

Affected QGIS version:master Regression?: No

Operating System: Easy fix?: No

Pull Request or Patch supplied: Resolution: fixed/implemented
Crashes QGIS or corrupls data: Copied to github as #: 16596
Description

In current master the connection to a PostGIS database is never released, even after all PostGIS layers have been removed from a map.
The only way to close the connection and release the PostGIS layer for editing in other clients is to completely close QGIS.

I'm not at all familiar with the postgres provider code, but it appears to me to be related to the check

if (-mRef>0)
return;

on line 260 of qgspostgreconn.cpp.

In my testing, mRef never reaches zero. Adding a single postgis layer to a map results in an mRef value of 2. Removing the postgis layer
drops this to 1, but it never hits 0 and as a result the connection is never removed and deleted.

Associated revisions

Revision 5f5cd4cc - 2013-10-24 11:26 PM - Giuseppe Sucameli

dbmanager: be sure to close db cursors (fix #7679)

History

#1 - 2013-04-23 01:54 AM - Jiirgen Fischer

Are you using the browser?

#2 - 2013-05-02 03:15 PM - Nyall Dawson

Yes, | was using the browser - that explains why mref never reached zero.

However, there's something else at play here. I've removed the browser, and now the connections.remove method is called. However, QGIS still seems to
hang on to a connection to the view/database.

To explain in more detail:

1. I start a new project and add a PostGIS view "census.vw_birthplace" to my map

2. I remove this layer. connections.remove is called by ggspostgreconn.cpp
3. A process remains active on the Postgresql database from QGIS - in this case the process is "SELECT pg_get_viewdef(c.oid) FROM pg_class ¢ JOIN

pg_namespace nsp ON c.relnamespace = nsp.oid WHERE relname="vw_birthplace' and nspname='census' and relkind="v

4. This process blocks any further changes to the census.vw_birthplace view

5. Closing QGIS removes the blocking process and allows changes to census.vw_birthplace view

#3 - 2013-05-02 03:22 PM - Nyall Dawson

Similarly, if | repeat the process with a table instead of a view the blocking process is:

"SELECT rulename, definition FROM pg_rules WHERE tablename='census_simplified' and schemaname="'census"

#4 - 2013-05-02 03:55 PM - Juirgen Fischer
- Category changed from Data Provider/PostGIS to DB Manager

Both queries are apparently is from the db_manager plugin.

#5 - 2013-05-02 04:19 PM - Nyall Dawson

Ok, | can confirm that -- if | don't use the DB_manager plugin to add the postgis layers then the connection is correctly released when the layer is removed.

#6 - 2013-08-13 03:21 AM - Nyall Dawson

- Subject changed from PostGIS connection is never released to DBManager does not release PostGIS connections

#7 - 2013-10-22 01:44 AM - Alexandre Neto

| can confirm this issue in QGIS 2.0 64bit in Windows 7.

#8 - 2013-10-24 02:26 PM - Giuseppe Sucameli
- Status changed from Open to Closed

Fixed in changeset commit:"5f5cd4cca9130c5dc0891ecdd52ee175cc538aab".

#9 - 2013-10-27 02:47 PM - Nyall Dawson
- Status changed from Closed to Reopened
- File locked_view.png added

Unfortunately I'm still seeing this after 5{5cd4c. I've attached a screenshot which shows the issue in PG Admin. The steps to reproduce are:

1. Use DB Manager to select a view (in this case "public.vw_test_7679")

2. Drag and drop that view to the map. DB manager runs a query "SELECT pg_get_viewdef(c.oid) FROM pg_class ...." (process 7296 in the attached
screenshot)

3. Close DB Manager, remove the view layer from the map -- the connection for process 7296 is still open

4. Attempt to edit the view in PG Admin but it is locked by process 7296.

5. Closing QGIS closes the connection and releases the lock
I'm happy to try any diagnose/debugging steps you'd like to help track this down.

#10 - 2014-05-02 03:51 AM - lvan Mincik

Nyall, DB Manager connects with default isolation level which leaves connection in (IDLE in transaction). You can try to change it in PostGisDBConnector

class by setting

self.connection.set_isolation_level(psycopg2.extensions.ISOLATION_LEVEL_AUTOCOMMIT)

Now you can edit tables in PG Admin when QGIS and even DB Manager are running, but some other things which require for example "named cursors"

will not work.

#11 - 2014-05-02 04:00 AM - lvan Mincik

By my quick test only displaying data from table is not working when setting ISOLATION_LEVEL_AUTOCOMMIT for connection.

#12 - 2014-05-02 05:37 AM - Ivan Mincik
- File connection-holding-fix.patch added

Here is a working patch which will fix connection holding issue by setting DB Manager connection to AUTOCOMMIT isolation level (which is better

practice). | have removed named cursor usage in PGTableDataModel._createCursor to fix problems when running with AUTOCOMMIT.

After few minutes of testing all functions it seems OK. Please test.

#13 - 2014-05-02 05:38 AM - lvan Mincik

- Assignee set to Giuseppe Sucameli

#14 - 2014-05-02 10:59 AM - Giovanni Manghi

- Status changed from Reopened to Feedback

- Pull Request or Patch supplied changed from No to Yes

lvan Mincik wrote:

Here is a working patch which will fix connection holding issue by setting DB Manager connection to AUTOCOMMIT isolation level (which is better
practice). | have removed named cursor usage in PGTableDataModel._createCursor to fix problems when running with AUTOCOMMIT.

After few minutes of testing all functions it seems OK. Please test.

Hi!

it would be better to make a Pull Request on github with your patch, otherwise the risk is that it will not be reviewed.

Thanks!

#15 - 2014-05-03 02:53 AM - Paolo Cavallini
- Assignee deleted (Giuseppe Sucameli)

#16 - 2014-05-13 05:37 AM - lvan Mincik

Thanks Paolo, done in https://github.com/qgis/QGIS/pull/1348

#17 - 2014-07-25 03:55 PM - Giuseppe Sucameli
- Status changed from Feedback to Closed
- Resolution set to fixed/implemented

Your pull request was merged in commit:d522059524. Thanks Ivan.

Files

locked_view.png 35.7 KB 2013-10-27 Nyall Dawson

connection-holding-fix.patch 1.65 KB 2014-05-02 Ivan Mincik
